CMSIS-DSP: Complex-by-Real Multiplication

| CMSIS-DSP Version 1.8.0 CMSIS DSP Software Library

- Main Page
- Usage and Description
- Reference

All Data Structures Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Functions
Complex-by-Real Multiplication
Complex Math Functions

## Functions

void | arm_cmplx_mult_real_f32 (const float32_t *pSrcCmplx, const float32_t *pSrcReal, float32_t *pCmplxDst, uint32_t numSamples)
| Floating-point complex-by-real multiplication. More...
void | arm_cmplx_mult_real_q15 (const q15_t *pSrcCmplx, const q15_t *pSrcReal, q15_t *pCmplxDst, uint32_t numSamples)
| Q15 complex-by-real multiplication. More...
void | arm_cmplx_mult_real_q31 (const q31_t *pSrcCmplx, const q31_t *pSrcReal, q31_t *pCmplxDst, uint32_t numSamples)
| Q31 complex-by-real multiplication. More...

## Description

Multiplies a complex vector by a real vector and generates a complex result. The data in the complex arrays is stored in an interleaved fashion (real, imag, real, imag, ...). The parameter `numSamples` represents the number of complex samples processed. The complex arrays have a total of `2*numSamples` real values while the real array has a total of `numSamples` real values.

The underlying algorithm is used:

    for (n = 0; n < numSamples; n++) {
        pCmplxDst[(2*n)+0] = pSrcCmplx[(2*n)+0] * pSrcReal[n];
        pCmplxDst[(2*n)+1] = pSrcCmplx[(2*n)+1] * pSrcReal[n];
    }

There are separate functions for floating-point, Q15, and Q31 data types.

## Function Documentation

void arm_cmplx_mult_real_f32 | ( | const float32_t * | pSrcCmplx,
|  | const float32_t * | pSrcReal,
|  | float32_t * | pCmplxDst,
|  | uint32_t | numSamples
| ) |  |

Parameters

  [in] | pSrcCmplx | points to complex input vector
  [in] | pSrcReal | points to real input vector
  [out] | pCmplxDst | points to complex output vector
  [in] | numSamples | number of samples in each vector

Returns
  none

void arm_cmplx_mult_real_q15 | ( | const q15_t * | pSrcCmplx,
|  | const q15_t * | pSrcReal,
|  | q15_t * | pCmplxDst,
|  | uint32_t | numSamples
| ) |  |

Parameters

  [in] | pSrcCmplx | points to complex input vector
  [in] | pSrcReal | points to real input vector
  [out] | pCmplxDst | points to complex output vector
  [in] | numSamples | number of samples in each vector

Returns
  none

Scaling and Overflow Behavior
  The function uses saturating arithmetic. Results outside of the allowable Q15 range [0x8000 0x7FFF] are saturated.

void arm_cmplx_mult_real_q31 | ( | const q31_t * | pSrcCmplx,
|  | const q31_t * | pSrcReal,
|  | q31_t * | pCmplxDst,
|  | uint32_t | numSamples
| ) |  |

Parameters

  [in] | pSrcCmplx | points to complex input vector
  [in] | pSrcReal | points to real input vector
  [out] | pCmplxDst | points to complex output vector
  [in] | numSamples | number of samples in each vector

Returns
  none

Scaling and Overflow Behavior
  The function uses saturating arithmetic. Results outside of the allowable Q31 range[0x80000000 0x7FFFFFFF] are saturated.